package assignment2;

import java.util.Arrays;

public class Pivoteer {
	public static void main(String[] args) {
		//pivotRangeInplace(new int[] {1,1,1,4,3,2,1,1,1}, 3, 5, 3);
		shrinkRange(new int[] {3,1,1,1,3,2,1,1,4}, 1, 3);
	}
	
	public static void shrinkRange(int[] arr, int loIndexInclude, int hiIndexInclude) {
		int rangeLo = 0;
		int rangeHi = arr.length - 1;
		
		int i = 0;
		
		PivotResult pr2 = new PivotResult(1, 1,1,new int[] {});
		int lastPivot = -1000; //OBSSSS
		
		//"cutting" the array using paritions
		//if we "shave off" some elements at either end by getting a bad parition, we adjust what range we partition and try again with a smaller array
		while(rangeLo < loIndexInclude && rangeHi > hiIndexInclude) {
			System.out.println("-- iter start");
			System.out.println("Low range: " + rangeLo);
			System.out.println("High range: " + rangeHi);
			//select pivot
			//take something within current range
			int pivotOn = arr[rangeLo]; //test pivot
			System.out.println("Selected pivot " + pivotOn + "(index " + rangeLo + ")");
			
			//We always pivot within the current range
			PivotResult pr = pivotRangeInplace(arr, rangeLo, rangeHi, pivotOn);
			pr.print();
			pr2 = pr;
			
			if(pr.li > hiIndexInclude) {
				rangeHi = pr.li - 1;
			}else if(pr.li < loIndexInclude){
				rangeLo = pr.li + 1;
			}
			lastPivot = pr.li;
			

			System.out.println("Low range: " + rangeLo);
			System.out.println("High range: " + rangeHi);
			

			System.out.println("-- iter end");
		}
		System.out.println("Cut middle, proceeding to single move iterations");
		int oldRangeLo = rangeLo;
		
		pr2.print();
		
		
		//this is the part where we start pivoting on two different ranges to pin down the exact positions of the percentile points - didn't work
		
		
		/*rangeLo = lastPivot + 1;
		while(rangeLo != hiIndexInclude && rangeHi != hiIndexInclude) {
			System.out.println("-- iter start");
			System.out.println("Low range: " + rangeLo);
			System.out.println("High range: " + rangeHi);
			//select pivot
			//take something within current range
			int pivotOn = arr[rangeLo];
			System.out.println("Selected pivot " + pivotOn + "(index " + rangeLo + ")");
			
			//We always pivot within the current range
			PivotResult pr = pivotRangeInplace(arr, rangeLo, rangeHi, pivotOn);
			pr.print();
			
			//obs
			if(pr.li > hiIndexInclude) {
				rangeHi = pr.li - 1;
			}else if(pr.li < hiIndexInclude){
				rangeLo = pr.li + 1;
			}
			lastPivot = pr.li;
			

			System.out.println("Low range: " + rangeLo);
			System.out.println("High range: " + rangeHi);
			

			System.out.println("-- iter end");
		}*/
	
	}
	

	public static PivotResult pivotRangeInplace(int[] arr, int lowIndex, int highIndex, int pivotOn) { //inclusive
		int newLength = highIndex - lowIndex + 1;
		int[] pivotedRange = new int[newLength];
		
		int ri = newLength - 1;
		int li = 0;
		boolean pivotSeen = false;
		
		for(int i = 0; i < newLength; i++) {
			int indexInOld = i + lowIndex;
			int elemInOld = arr[indexInOld];
			
			if(!pivotSeen && elemInOld == pivotOn) {
				pivotSeen = true;
				continue;
			}
			
			if(elemInOld >= pivotOn) {
				pivotedRange[ri--] = elemInOld;
			}else {
				pivotedRange[li++] = elemInOld;
			}
		}
		
		pivotedRange[li] = pivotOn;
		
		for(int i = 0; i < newLength;i++) {
			int indexInOld = i + lowIndex;
			arr[indexInOld] = pivotedRange[i];
		}
		
		return new PivotResult(lowIndex, highIndex, lowIndex + li, arr);
	}
	
	private static class PivotResult {
		int lowIndex;
		int highIndex;
		int li;	//pivot is "gte". meaning pivot is first in gte arr
		int[] arrCopy;
		public PivotResult(int lowIndex, int highIndex, int li, int[] arr){
			this.lowIndex = lowIndex;
			this.highIndex = highIndex;
			this.li = li;
			this.arrCopy = Arrays.copyOf(arr,arr.length);
		}
		public void print() {
			System.out.println("Unpivoted elems: " + Arrays.toString(Arrays.copyOfRange(arrCopy,0,lowIndex)));
			System.out.println("Pivoted lower lt piv: " + Arrays.toString(Arrays.copyOfRange(arrCopy,lowIndex,lowIndex+li)));
			System.out.println("Pivoted elems gte piv: " + Arrays.toString(Arrays.copyOfRange(arrCopy,lowIndex+li,highIndex+1)));
			System.out.println("Unpivoted elems: " + Arrays.toString(Arrays.copyOfRange(arrCopy,highIndex+1,arrCopy.length)));
			System.out.println("Pivot index is: " + li);
		}
	}
	

}
