package assignment1AADS;

public class MyIntegerBSTTest {

	@SuppressWarnings("unused")
	public static void main(String[] args) {
		System.out.println("\n---- printing the tree in the example ----");
		MyIntegerBST tree = new MyIntegerBST();
		tree.insert(10);
		System.out.println(tree.toString());
		tree.insert(7);
		tree.insert(20);
		System.out.println(tree.toString());
		tree.insert(4);
		tree.insert(9);
		tree.insert(8);
		tree.insert(25);
		System.out.println(tree.toString());
		
		if (false) {
			System.out.println("\n---- testing the queue ----");
			MyQueue<Integer> testQ = new MyQueue<>();
			testQ.enqueue(1);
			testQ.enqueue(2);
			testQ.enqueue(3);
			testQ.dequeue();
			testQ.enqueue(4);
			System.out.println(testQ.dequeue());
			System.out.println(testQ.dequeue());
			System.out.println(testQ.dequeue());
			testQ.enqueue(8);
			System.out.println(testQ.dequeue());
			testQ.enqueue(1337);
			testQ.enqueue(420);
			System.out.println(testQ.dequeue());
			System.out.println(testQ.dequeue());
		}
		
		System.out.println("\n---- print by levels ----");
		tree.printByLevels();
		
		System.out.println("\n---- mostSimilarValue ----");
		System.out.println("most similar to 18: " + tree.mostSimilarValue(18));
		System.out.println("most similar to 21: " + tree.mostSimilarValue(21));
		System.out.println("most similar to 24: " + tree.mostSimilarValue(24));
		System.out.println("most similar to 1: " + tree.mostSimilarValue(1));
		System.out.println("most similar to 9: " + tree.mostSimilarValue(9));
		System.out.println("most similar to 15: " + tree.mostSimilarValue(15));
		
		if (false) {
			System.out.println("\n---- mostSimilarValue, further test ----");
			MyIntegerBST tree2 = new MyIntegerBST();
			tree2.insert(21);
			tree2.insert(22);
			tree2.insert(16);
			tree2.insert(20);
			tree2.insert(10);
			System.out.println("most similar to 21: " + tree2.mostSimilarValue(21));
			System.out.println("most similar to 19: " + tree2.mostSimilarValue(19));
			System.out.println("most similar to 0: " + tree2.mostSimilarValue(0));
			System.out.println("most similar to 15: " + tree2.mostSimilarValue(15));
			System.out.println("most similar to -100: " + tree2.mostSimilarValue(-100));
		}
		
		largeTree(10024);
	}
	
	public static void largeTree(int size) {
		MyIntegerBST tree = new MyIntegerBST();
		tree.insert(size/2);
		popHalf(tree, size/2, size/100);
		System.out.println("d");
		System.out.println(tree);
		tree.printByLevels();
	}
	public static void popHalf(MyIntegerBST tree, int size, int it) {
		int half = size/3;
		int nexthalf = half+size;
		tree.insert(half);
		tree.insert(nexthalf);
		if (it > 0) {
			popHalf(tree, half, it-1);
			popHalf(tree, nexthalf, it-1);
		}
	}

}
